<template>
  <section class="main-content">

    <breadcrumb separator="›">
      <breadcrumb-item label="Início" to="/admin"></breadcrumb-item>
    </breadcrumb>

    <nav class="nav" style="margin-bottom: 50px">
      <div class="nav-left">
        <div class="nav-item">
          <h2 class="title">Adicione uma localização para a Iniciativa</h2>
        </div>
      </div>
    </nav>

    <div class="columns">
      <div class="column is-6 is-offset-3">
        <div class="control">
          <h3>Título da Iniciativa</h3>
          <span>{{getCurrentIniciativa.titulo}}</span>
        </div>
        <div class="control">
          <h3>Descrição da Iniciativa</h3>
          <span>{{getCurrentIniciativa.desc}}</span>
        </div>
        <h3>Endereço</h3>
        <p class="control has-addons">
            <GmapAutocomplete class="input" style="width: 100%" @place_changed="setPlace"></GmapAutocomplete>
            <button class="button is-primary" @click="usePlace">Adicionar</button>
        </p>
        <div class="control">
          <GmapMap style="width: 100%; height: 500px;" :zoom="mapZoom" :center="mapCenter">
            <GmapMarker
              :position="marker.position"
              />
            <GmapMarker
              v-if="this.place"
              label="★"
              :position="{
                lat: this.place.geometry.location.lat(),
                lng: this.place.geometry.location.lng(),
              }"
              />
          </GmapMap>
        </div>
        <div class="control">
          <div class="has-text-right">
            <button class="button is-primary" @click="save()">Concluir</button>
          </div>
        </div>
      </div>
    </div>

  </section>
</template>

<script>
  import { mapGetters } from 'vuex'

  export default {
    name: 'AdicionarIniciativaMapa',

    data () {
      return {
        mapCenter: { lat: -14.235004, lng: -51.92527999999999 },
        mapZoom: 5,
        marker: {},
        place: null,
      }
    },

    mounted() {
      navigator.geolocation.getCurrentPosition(
        (pos) => this.mapCenter = { lat: pos.coords.latitude, lng: pos.coords.longitude }
      )
    },

    methods: {
      setDescription(description) {
        this.description = description;
      },
      setPlace(place) {
        this.place = place;
        this.mapZoom = 13;
      },
      usePlace(place) {
        if (this.place) {
          this.mapZoom = 15;
          this.marker = {
            position: {
              lat: this.place.geometry.location.lat(),
              lng: this.place.geometry.location.lng()
            }
          };
          this.mapCenter = {
            lat: this.place.geometry.location.lat(),
            lng: this.place.geometry.location.lng()
          }
          this.place = null;
        }
      },
      save() {

      }
    },

    computed: {
      ...mapGetters(['getCurrentIniciativa'])
    }
  }
</script>
